Index: drivers/net/wireless/orinoco_plx.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/orinoco_plx.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wireless/orinoco_plx.c	22 Jul 2004 19:49:45 -0000	1.1
+++ drivers/net/wireless/orinoco_plx.c	4 Aug 2004 01:29:26 -0000	1.2
@@ -1,4 +1,4 @@
-/* orinoco_plx.c 0.13b
+/* orinoco_plx.c 0.13d
  * 
  * Driver for Prism II devices which would usually be driven by orinoco_cs,
  * but are connected to the PCI bus by a PLX9052. 
@@ -243,7 +243,7 @@
 			HERMES_IO, HERMES_16BIT_REGSPACING);
 	pci_set_drvdata(pdev, dev);
 
-	err = request_irq(pdev->irq, orinoco_interrupt, SA_SHIRQ, dev->name, priv);
+	err = request_irq(pdev->irq, orinoco_interrupt, SA_SHIRQ, dev->name, dev);
 	if (err) {
 		printk(KERN_ERR "orinoco_plx: Error allocating IRQ %d.\n", pdev->irq);
 		err = -EBUSY;
@@ -266,7 +266,7 @@
 			unregister_netdev(dev);
 		
 		if (dev->irq)
-			free_irq(dev->irq, priv);
+			free_irq(dev->irq, dev);
 		
 		kfree(priv);
 	}
@@ -285,7 +285,6 @@
 static void __devexit orinoco_plx_remove_one(struct pci_dev *pdev)
 {
 	struct net_device *dev = pci_get_drvdata(pdev);
-	struct orinoco_private *priv = dev->priv;
 
 	if (! dev)
 		BUG();
@@ -293,7 +292,7 @@
 	unregister_netdev(dev);
 		
 	if (dev->irq)
-		free_irq(dev->irq, priv);
+		free_irq(dev->irq, dev);
 		
 	pci_set_drvdata(pdev, NULL);
 
@@ -334,7 +333,7 @@
 	.resume		= 0,
 };
 
-static char version[] __initdata = "orinoco_plx.c 0.13b (Daniel Barlow <dan@telent.net>, David Gibson <hermes@gibson.dropbear.id.au>)";
+static char version[] __initdata = "orinoco_plx.c 0.13d (Daniel Barlow <dan@telent.net>, David Gibson <hermes@gibson.dropbear.id.au>)";
 MODULE_AUTHOR("Daniel Barlow <dan@telent.net>");
 MODULE_DESCRIPTION("Driver for wireless LAN cards using the PLX9052 PCI bridge");
 #ifdef MODULE_LICENSE
Index: drivers/net/wireless/at76c503/at76c503-i3861.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/at76c503/at76c503-i3861.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wireless/at76c503/at76c503-i3861.c	8 Oct 2004 23:12:15 -0000	1.1
+++ drivers/net/wireless/at76c503/at76c503-i3861.c	21 Oct 2004 22:24:58 -0000	1.2
@@ -1,6 +1,6 @@
 /* -*- linux-c -*- */
 /*
- * $Id: at76c503-i3861.c,v 1.1 2004/10/08 23:12:15 liberty Exp $
+ * $Id: at76c503-i3861.c,v 1.2 2004/10/21 22:24:58 joff Exp $
  *
  * Driver for at76c503-based devices based on the Atmel "Fast-Vnet" reference
  * design using Intersil 3861 radio chips
@@ -39,7 +39,7 @@
 # ifdef CONFIG_AT76C503_FIRMWARE_DOWNLOAD
 #  error firmware download from user space unavail. with this kernel
 # endif
-# define FIRMWARE_NAME_MAX 30 
+# define FIRMWARE_NAME_MAX 50 
 struct firmware {
 	size_t size;
 	u8 *data;
Index: drivers/net/wireless/at76c503/at76c503-i3863.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/at76c503/at76c503-i3863.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wireless/at76c503/at76c503-i3863.c	8 Oct 2004 23:12:15 -0000	1.1
+++ drivers/net/wireless/at76c503/at76c503-i3863.c	21 Oct 2004 22:24:58 -0000	1.2
@@ -1,6 +1,6 @@
 /* -*- linux-c -*- */
 /*
- * $Id: at76c503-i3863.c,v 1.1 2004/10/08 23:12:15 liberty Exp $
+ * $Id: at76c503-i3863.c,v 1.2 2004/10/21 22:24:58 joff Exp $
  *
  * Driver for at76c503-based devices based on the Atmel "Fast-Vnet" reference
  * design using a Intersil 3863 radio chip
@@ -38,7 +38,7 @@
 # ifdef CONFIG_AT76C503_FIRMWARE_DOWNLOAD
 #  error firmware download from user space unavail. with this kernel
 # endif
-# define FIRMWARE_NAME_MAX 30 
+# define FIRMWARE_NAME_MAX 50 
 struct firmware {
 	size_t size;
 	u8 *data;
Index: drivers/net/wireless/at76c503/at76c503-rfmd-acc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/at76c503/at76c503-rfmd-acc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wireless/at76c503/at76c503-rfmd-acc.c	8 Oct 2004 23:12:15 -0000	1.1
+++ drivers/net/wireless/at76c503/at76c503-rfmd-acc.c	21 Oct 2004 22:24:58 -0000	1.2
@@ -1,6 +1,6 @@
 /* -*- linux-c -*- */
 /*
- * $Id: at76c503-rfmd-acc.c,v 1.1 2004/10/08 23:12:15 liberty Exp $
+ * $Id: at76c503-rfmd-acc.c,v 1.2 2004/10/21 22:24:58 joff Exp $
  *
  * Driver for at76c503-based devices based on the Atmel "Fast-Vnet" reference
  * design using RFMD radio chips in the Accton OEM layout.
@@ -38,7 +38,7 @@
 # ifdef CONFIG_AT76C503_FIRMWARE_DOWNLOAD
 #  error firmware download from user space unavail. with this kernel
 # endif
-# define FIRMWARE_NAME_MAX 30 
+# define FIRMWARE_NAME_MAX 50 
 struct firmware {
 	size_t size;
 	u8 *data;
Index: drivers/net/wireless/at76c503/at76c503-rfmd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/at76c503/at76c503-rfmd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wireless/at76c503/at76c503-rfmd.c	8 Oct 2004 23:12:15 -0000	1.1
+++ drivers/net/wireless/at76c503/at76c503-rfmd.c	21 Oct 2004 22:24:58 -0000	1.2
@@ -1,6 +1,6 @@
 /* -*- linux-c -*- */
 /*
- * $Id: at76c503-rfmd.c,v 1.1 2004/10/08 23:12:15 liberty Exp $
+ * $Id: at76c503-rfmd.c,v 1.2 2004/10/21 22:24:58 joff Exp $
  *
  * Driver for at76c503-based devices based on the Atmel "Fast-Vnet" reference
  * design using RFMD radio chips
@@ -47,7 +47,7 @@
 # ifdef CONFIG_AT76C503_FIRMWARE_DOWNLOAD
 #  error firmware download from user space unavail. with this kernel
 # endif
-# define FIRMWARE_NAME_MAX 30 
+# define FIRMWARE_NAME_MAX 50 
 struct firmware {
 	size_t size;
 	u8 *data;
Index: drivers/net/wireless/at76c503/at76c505-rfmd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/at76c503/at76c505-rfmd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wireless/at76c503/at76c505-rfmd.c	8 Oct 2004 23:12:15 -0000	1.1
+++ drivers/net/wireless/at76c503/at76c505-rfmd.c	21 Oct 2004 22:24:58 -0000	1.2
@@ -1,6 +1,6 @@
 /* -*- linux-c -*- */
 /*
- * $Id: at76c505-rfmd.c,v 1.1 2004/10/08 23:12:15 liberty Exp $
+ * $Id: at76c505-rfmd.c,v 1.2 2004/10/21 22:24:58 joff Exp $
  *
  * Driver for at76c503-based devices based on the Atmel "Fast-Vnet" reference
  * design using at76c505 with RFMD radio chips
@@ -37,7 +37,7 @@
 # ifdef CONFIG_AT76C503_FIRMWARE_DOWNLOAD
 #  error firmware download from user space unavail. with this kernel
 # endif
-# define FIRMWARE_NAME_MAX 30 
+# define FIRMWARE_NAME_MAX 50 
 struct firmware {
 	size_t size;
 	u8 *data;
Index: drivers/net/wireless/at76c503/at76c505-rfmd2958.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/at76c503/at76c505-rfmd2958.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wireless/at76c503/at76c505-rfmd2958.c	8 Oct 2004 23:12:15 -0000	1.1
+++ drivers/net/wireless/at76c503/at76c505-rfmd2958.c	21 Oct 2004 22:24:58 -0000	1.2
@@ -39,7 +39,7 @@
 # ifdef CONFIG_AT76C503_FIRMWARE_DOWNLOAD
 #  error firmware download from user space unavail. with this kernel
 # endif
-# define FIRMWARE_NAME_MAX 30 
+# define FIRMWARE_NAME_MAX 50 
 struct firmware {
 	size_t size;
 	u8 *data;
Index: drivers/net/wireless/at76c503/at76c505a-rfmd2958.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/at76c503/at76c505a-rfmd2958.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wireless/at76c503/at76c505a-rfmd2958.c	8 Oct 2004 23:12:15 -0000	1.1
+++ drivers/net/wireless/at76c503/at76c505a-rfmd2958.c	21 Oct 2004 22:24:58 -0000	1.2
@@ -1,6 +1,6 @@
 /* -*- linux-c -*- */
 /*
- * $Id: at76c505a-rfmd2958.c,v 1.1 2004/10/08 23:12:15 liberty Exp $
+ * $Id: at76c505a-rfmd2958.c,v 1.2 2004/10/21 22:24:58 joff Exp $
  *
  * Driver for at76c503-based devices based on the Atmel "Fast-Vnet" reference
  * design using a at76c505a (with RFMD radio chips ?)
@@ -37,7 +37,7 @@
 # ifdef CONFIG_AT76C503_FIRMWARE_DOWNLOAD
 #  error firmware download from user space unavail. with this kernel
 # endif
-# define FIRMWARE_NAME_MAX 30 
+# define FIRMWARE_NAME_MAX 50 
 struct firmware {
 	size_t size;
 	u8 *data;
Index: drivers/net/wireless/zd1211-driver-r51/src/zd1211.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/wireless/zd1211-driver-r51/src/zd1211.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/wireless/zd1211-driver-r51/src/zd1211.c	17 Jan 2006 20:36:03 -0000	1.1
+++ drivers/net/wireless/zd1211-driver-r51/src/zd1211.c	17 Jan 2006 23:43:10 -0000	1.2
@@ -589,7 +589,7 @@
                 //check if Rsp has completed, race condition may happen,
                 macp->regRdSleepCnt++;
                 //we waste time_out time
-                printk(KERN_ERR "before wait 2\n");
+                //printk(KERN_ERR "before wait 2\n");
                 interruptible_sleep_on_timeout(&macp->iorwRsp_wait, HZ/2);
                 //wake up, check if timeout or ompleted
 
Index: drivers/parport/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/parport/Config.in,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/parport/Config.in	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/parport/Config.in	4 Aug 2004 01:29:26 -0000	1.2
@@ -24,13 +24,7 @@
          bool '    Use FIFO/DMA if available (EXPERIMENTAL)' CONFIG_PARPORT_PC_FIFO
          bool '    SuperIO chipset support (EXPERIMENTAL)' CONFIG_PARPORT_PC_SUPERIO
       fi
-      if [ "$CONFIG_HOTPLUG" = "y" -a "$CONFIG_PCMCIA" != "n" ]; then
-         if [ "$CONFIG_PARPORT_PC" = "y" ]; then
-            dep_tristate '    Support for PCMCIA management for PC-style ports' CONFIG_PARPORT_PC_PCMCIA $CONFIG_PCMCIA
-         else
-            dep_tristate '    Support for PCMCIA management for PC-style ports' CONFIG_PARPORT_PC_PCMCIA $CONFIG_PARPORT_PC
-         fi
-      fi
+      dep_tristate '    Support for PCMCIA management for PC-style ports' CONFIG_PARPORT_PC_PCMCIA $CONFIG_PCMCIA $CONFIG_PARPORT_PC $CONFIG_HOTPLUG
    fi
    if [ "$CONFIG_ARM" = "y" ]; then
       dep_tristate '  Archimedes hardware' CONFIG_PARPORT_ARC $CONFIG_PARPORT $CONFIG_ARCH_ARC
@@ -62,6 +56,12 @@
       define_tristate CONFIG_PARPORT_SUNBPP n
    fi
 
+   if [ "$CONFIG_SGI_IP22" = "y" -a "$CONFIG_EXPERIMENTAL" = "y" ]; then
+      dep_tristate '  SGI Indy/Indigo2 hardware (EXPERIMENTAL)' CONFIG_PARPORT_IP22 $CONFIG_PARPORT
+   else
+      define_tristate CONFIG_PARPORT_IP22 n
+   fi
+
    # If exactly one hardware type is selected then parport will optimise away
    # support for loading any others.  Defeat this if the user is keen.
    bool '  Support foreign hardware' CONFIG_PARPORT_OTHER
Index: drivers/parport/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/parport/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/parport/Makefile	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/parport/Makefile	4 Aug 2004 01:29:26 -0000	1.2
@@ -23,13 +23,14 @@
 obj-$(CONFIG_PARPORT)		+= parport.o
 obj-$(CONFIG_PARPORT_PC)	+= parport_pc.o
 obj-$(CONFIG_PARPORT_SERIAL)	+= parport_serial.o
-obj-$(CONFIG_PARPORT_PC_PCMCIA)+= parport_cs.o
+obj-$(CONFIG_PARPORT_PC_PCMCIA)	+= parport_cs.o
 obj-$(CONFIG_PARPORT_AMIGA)	+= parport_amiga.o
 obj-$(CONFIG_PARPORT_MFC3)	+= parport_mfc3.o
 obj-$(CONFIG_PARPORT_ATARI)	+= parport_atari.o
 obj-$(CONFIG_PARPORT_SUNBPP)	+= parport_sunbpp.o
 obj-$(CONFIG_PARPORT_GSC)	+= parport_gsc.o
 obj-$(CONFIG_PARPORT_IDP)	+= parport_idp.o
+obj-$(CONFIG_PARPORT_IP22)	+= parport_ip22.o
 
 include $(TOPDIR)/Rules.make
 
Index: drivers/parport/ieee1284.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/parport/ieee1284.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/parport/ieee1284.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/parport/ieee1284.c	4 Aug 2004 01:29:26 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: ieee1284.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+/* $Id: ieee1284.c,v 1.2 2004/08/04 01:29:26 joff Exp $
  * IEEE-1284 implementation for parport.
  *
  * Authors: Phil Blundell <Philip.Blundell@pobox.com>
Index: drivers/parport/parport_sunbpp.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/parport/parport_sunbpp.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/parport/parport_sunbpp.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/parport/parport_sunbpp.c	4 Aug 2004 01:29:26 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: parport_sunbpp.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+/* $Id: parport_sunbpp.c,v 1.2 2004/08/04 01:29:26 joff Exp $
  * Parallel-port routines for Sun architecture
  * 
  * Author: Derrick J. Brashear <shadow@dementia.org>
Index: drivers/parport/probe.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/parport/probe.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/parport/probe.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/parport/probe.c	4 Aug 2004 01:29:26 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: probe.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+/* $Id: probe.c,v 1.2 2004/08/04 01:29:26 joff Exp $
  * Parallel port device probing code
  *
  * Authors:    Carsten Gross, carsten@sol.wohnheim.uni-ulm.de
Index: drivers/parport/share.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/parport/share.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/parport/share.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/parport/share.c	4 Aug 2004 01:29:26 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: share.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+/* $Id: share.c,v 1.2 2004/08/04 01:29:26 joff Exp $
  * Parallel-port resource manager code.
  * 
  * Authors: David Campbell <campbell@tirian.che.curtin.edu.au>
Index: drivers/pci/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/pci/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/pci/Makefile	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/pci/Makefile	4 Aug 2004 01:29:26 -0000	1.2
@@ -29,7 +29,6 @@
 obj-$(CONFIG_SUPERH) += setup-bus.o setup-irq.o
 obj-$(CONFIG_PPC32) += setup-irq.o
 obj-$(CONFIG_SGI_IP27) += setup-irq.o
-obj-$(CONFIG_SGI_IP32) += setup-irq.o
 
 ifndef CONFIG_X86
 obj-y += syscall.o
Index: drivers/pci/compat.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/pci/compat.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/pci/compat.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/pci/compat.c	4 Aug 2004 01:29:26 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- *	$Id: compat.c,v 1.1 2004/07/22 19:49:46 joff Exp $
+ *	$Id: compat.c,v 1.2 2004/08/04 01:29:26 joff Exp $
  *
  *	PCI Bus Services -- Function For Backward Compatibility
  *
Index: drivers/pci/pci.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/pci/pci.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/pci/pci.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/pci/pci.c	4 Aug 2004 01:29:26 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- *	$Id: pci.c,v 1.1 2004/07/22 19:49:46 joff Exp $
+ *	$Id: pci.c,v 1.2 2004/08/04 01:29:26 joff Exp $
  *
  *	PCI Bus Services, see include/linux/pci.h for further explanation.
  *
@@ -949,8 +949,12 @@
 	pcibios_set_master(dev);
 }
 
+#ifndef HAVE_ARCH_PCI_MWI
+/* This can be overridden by arch code. */
+u8 pci_cache_line_size = L1_CACHE_BYTES >> 2;
+
 /**
- * pdev_set_mwi - arch helper function for pcibios_set_mwi
+ * pci_generic_prep_mwi - helper function for pci_set_mwi
  * @dev: the PCI device for which MWI is enabled
  *
  * Helper function for implementation the arch-specific pcibios_set_mwi
@@ -959,35 +963,34 @@
  *
  * RETURNS: An appriopriate -ERRNO error value on eror, or zero for success.
  */
-int
-pdev_set_mwi(struct pci_dev *dev)
+static int
+pci_generic_prep_mwi(struct pci_dev *dev)
 {
-	int rc = 0;
-	u8 cache_size;
+	u8 cacheline_size;
 
-	/*
-	 * Looks like this is necessary to deal with on all architectures,
-	 * even this %$#%$# N440BX Intel based thing doesn't get it right.
-	 * Ie. having two NICs in the machine, one will have the cache
-	 * line set at boot time, the other will not.
-	 */
-	pci_read_config_byte(dev, PCI_CACHE_LINE_SIZE, &cache_size);
-	cache_size <<= 2;
-	if (cache_size != SMP_CACHE_BYTES) {
-		printk(KERN_WARNING "PCI: %s PCI cache line size set incorrectly (%i bytes) by BIOS/FW.\n",
-		       dev->slot_name, cache_size);
-		if (cache_size > SMP_CACHE_BYTES) {
-			printk("PCI: %s cache line size too large - expecting %i.\n", dev->slot_name, SMP_CACHE_BYTES);
-			rc = -EINVAL;
-		} else {
-			printk("PCI: %s PCI cache line size corrected to %i.\n", dev->slot_name, SMP_CACHE_BYTES);
-			pci_write_config_byte(dev, PCI_CACHE_LINE_SIZE,
-					      SMP_CACHE_BYTES >> 2);
-		}
-	}
+	if (!pci_cache_line_size)
+		return -EINVAL;		/* The system doesn't support MWI. */
+
+	/* Validate current setting: the PCI_CACHE_LINE_SIZE must be
+	   equal to or multiple of the right value. */
+	pci_read_config_byte(dev, PCI_CACHE_LINE_SIZE, &cacheline_size);
+	if (cacheline_size >= pci_cache_line_size &&
+	    (cacheline_size % pci_cache_line_size) == 0)
+		return 0;
+
+	/* Write the correct value. */
+	pci_write_config_byte(dev, PCI_CACHE_LINE_SIZE, pci_cache_line_size);
+	/* Read it back. */
+	pci_read_config_byte(dev, PCI_CACHE_LINE_SIZE, &cacheline_size);
+	if (cacheline_size == pci_cache_line_size)
+		return 0;
 
-	return rc;
+	printk(KERN_WARNING "PCI: cache line size of %d is not supported "
+	       "by device %s\n", pci_cache_line_size << 2, dev->slot_name);
+
+	return -EINVAL;
 }
+#endif /* !HAVE_ARCH_PCI_MWI */
 
 /**
  * pci_set_mwi - enables memory-write-invalidate PCI transaction
@@ -1008,7 +1011,7 @@
 #ifdef HAVE_ARCH_PCI_MWI
 	rc = pcibios_set_mwi(dev);
 #else
-	rc = pdev_set_mwi(dev);
+	rc = pci_generic_prep_mwi(dev);
 #endif
 
 	if (rc)
@@ -1514,17 +1517,22 @@
 	u8 hdr_type;
 
 	for (func = 0; func < 8; func++, temp->devfn++) {
-		if (func && !is_multi)		/* not a multi-function device */
-			continue;
 		if (pci_read_config_byte(temp, PCI_HEADER_TYPE, &hdr_type))
 			continue;
 		temp->hdr_type = hdr_type & 0x7f;
 
 		dev = pci_scan_device(temp);
-		if (!dev)
-			continue;
+		if (!pcibios_scan_all_fns() && func == 0) {
+			if (!dev)
+				break;
+		} else {
+			if (!dev)
+				continue;
+			is_multi = 1;
+		}
+
 		pci_name_device(dev);
-		if (!func) {
+		if (!first_dev) {
 			is_multi = hdr_type & 0x80;
 			first_dev = dev;
 		}
@@ -1538,6 +1546,14 @@
 
 		/* Fix up broken headers */
 		pci_fixup_device(PCI_FIXUP_HEADER, dev);
+
+		/*
+		 * If this is a single function device
+		 * don't scan past the first function.
+		 */
+		if (!is_multi)
+			break;
+
 	}
 	return first_dev;
 }
@@ -2190,7 +2206,6 @@
 EXPORT_SYMBOL(pci_set_master);
 EXPORT_SYMBOL(pci_set_mwi);
 EXPORT_SYMBOL(pci_clear_mwi);
-EXPORT_SYMBOL(pdev_set_mwi);
 EXPORT_SYMBOL(pci_set_dma_mask);
 EXPORT_SYMBOL(pci_dac_set_dma_mask);
 EXPORT_SYMBOL(pci_assign_resource);
